/*
 * Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/
 * Contact: beat.support@idiap.ch
 *
 * This file is part of the beat.web module of the BEAT platform.
 *
 * Commercial License Usage
 * Licensees holding valid commercial BEAT licenses may use this file in
 * accordance with the terms contained in a written agreement between you
 * and Idiap. For further information contact tto@idiap.ch
 *
 * Alternatively, this file may be used under the terms of the GNU Affero
 * Public License version 3 as published by the Free Software and appearing
 * in the file LICENSE.AGPL included in the packaging of this file.
 * The BEAT platform is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * You should have received a copy of the GNU Affero Public License along
 * with the BEAT platform. If not, see http://www.gnu.org/licenses/.
 */
//This factory retrieves data from the REST API and associates it with the $scope
angular.module('reportApp').factory('experimentFactory', ['$http', 'UrlService', function($http, UrlService){
    let urlBase = '/api/v1/experiments';
    let prefix = new URL(UrlService.getPrefix()).pathname;
    if(prefix.endsWith('/'))
	prefix = prefix.slice(0, -1);

    return {
        getExperimentInformation: function (url_prefix, experiment_id){
	    let base = prefix + urlBase;
            return $http.get(base + '/' + experiment_id + '/')
            .then(function(response){
                return response.data;
            });
        },

        getAllExperimentResultsForAuthor: function (user, report_id, url_prefix){
	    let base = prefix + '/api/v1/reports';
            return $http.get(base + '/' + user + '/' + report_id + '/results_author/')
            .then(function(response){
                return response.data;
            });
        },

        getAllExperimentResults: function (url_prefix, report_number){
	    let base = prefix + '/api/v1/reports';
            return $http.get(base + '/' + report_number + '/results/')
            .then(function(response){
                return response.data;
            });
        }
    };
}]);
